<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class WithdrawRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [
            'wtype' => 'required',
            'method' => 'required',
            'amount' => 'required|numeric',
            'payDate' => 'required|date_format:d/m/Y',
            'payTime' => 'required|date_format:H:i:s',
            'branch' => 'required'
        ];

        if($this->input('wname')!='') {
            $rules = array_merge($rules,['wname' => 'required']);
        }
        if($this->input('teachDate')!='') {
            $rules = array_merge($rules,['teachDate' => 'required']);
            $rules = array_merge($rules,['teachDate' => 'required|date_format:m-Y']);
        }

        return $rules;
    }

    public function messages()
    {
        $msg = [
            'wtype.required' => 'กรุณาเลือกประเภทรายการเบิก',
            'method.required' => 'กรุณาเลือกประเภทการจ่ายเงิน',
            'amount.required' => 'กรุณากรอกจำนวนเงิน',
            'amount.numeric' => 'กรุณากรอกเป็นตัวเลขเท่านั้น',
            'payDate.required' => 'กรุณากรอกวันที่',
            'payDate.date_format:d/m/Y' => 'กรุณากรอกรูปแบบวันที่ให้ถูกต้อง วัน/เดือน/ปี',
            'payTime.required' => 'กรุณากรอกเวลา',
            'payTime.date_format:H:i:s' => 'กรุณากรอกรูปแบบเวลาให้ถูกต้อง ชม.:นาที:วินาที',
            'branch.required' => 'กรุณาเลือกสาขาที่ทำรายการ'
        ];

        if($this->input('wname')!='') {
            $msg = array_merge($msg,['wname.required' => 'กรุณากรอกรายการเบิก']);
        }
        if($this->input('teachDate')!='') {
            $msg = array_merge($msg,['teachDate.required' => 'กรุณากรอกวันที่สอน']);
            $msg = array_merge($msg,['teachDate.date_format:d/m/Y' => 'กรุณากรอกรูปแบบวันที่ให้ถูกต้อง วัน/เดือน/ปี']);
        }

        return $msg;
    }
}
